# Illuminated horns for a bicycle helmet

This is Arduino code to drive 2 led rings for the smallest model from this [thing](https://www.thingiverse.com/thing:344412).

The front half is white and the rear half is read and the LEDs are "randomly" illuminated. The right side is a mirror of the left.

## BOM

* [Cheapduino from DFRobot](https://www.dfrobot.com/product-899.html)
* [12 LED WS2182B ring](https://www.ebay.co.uk/itm/12-Bit-Channel-WS2812b-RGB-LED-Ring-Module-5050-PLCC-UK-First-Class/273694051407) x2
* [1000mAh LiPo battery, measuring 34x50x5mm (WxLxH)](https://www.ebay.co.uk/itm/10x-3-7V-1000mAh-JST-PH2-0-lipo-Rechargeable-Battery-For-MP3-mobile-phone-503450/112677366789)
* [5c lithium charge/discharge module](https://www.ebay.co.uk/itm/2A-5V-4in1-Li-ion-Battery-Charger-Discharge-Module-3-7V-4-2V-Charge-Boost-Board/133124533372)
* [Mini SPST rocker switch](https://www.ebay.co.uk/itm/Small-Mini-Black-On-Off-Rocker-Switch-Rectangle-SPST-12V-All-Quantities/251390016446)
* [Micro USB breakout board](https://www.ebay.co.uk/itm/10x-Female-Micro-USB-to-DIP-Adapter-Converter-2-54mm-PCB-Breakout-Board-DIY/331967820483)
* 3 core wire
* Single core wire
* JST-SM 3 pin connectors x2
* Heat shrink
* M2x4mm screws x12
* M3x20mm screw (this may change for you)
* Cable ties x4
* 3D printer

## Construction

1. Print out the 3D models found in the models folder and the Thingiverse link above.
2. Upload the code to the Cheapduino.
3. Cut some of the 3 core wire to the appropriate length to go from the horns to where you want to mount the battery box.
4. Solder the 3 core wire to the LED rings and crimp on the female JST connectors.
5. Cut any existing connector off the battery and solder the wires to the matching pads on the charge controller.
6. Use some single core wire to connect the micro USB breakout to the charge controller, and solder in to place.
7. Cut enough single core wire to go from the switch to the inside of the battery box, with enough slack for you to work with.
8. Solder some of the single core wire to each terminal of the switch.
9. Push switch in to place.
10. Solder one of the switch wires to the VOUT on the charge controller.
11. Cut enough 3 core wire to thread through the holes in the battery box to reach the Cheapduino with enough on the outside to attach a JST connector.
12. Cut another of the same length.
13. Crimp on a male JST connector on each length of wire.
14. Solder a positive and negative wire on to the Cheapduino.
15. Insert the short lengths of 3 core wire to the battery box and solder the data pins to the Cheapduino (check source code for pin layout).
16. Solder all the remaining unsoldered positive wires to eachother and apply heatshrink. Do the same for the negative.
17. Press in and screw down the microusb connector in to the battery box using 2 of the M2 screws.
18. Connect everything and make sure it all works.
19. Disconnect everything.
20. Press it all in to the battery box and use the remaining 8 M2 screws to attach the lid.
21. Using the M3 screw, fasten the box to the helmet using the fastener from the inside.
22. Press the LED rings in to the horns and cable tie the horns to the helmet.
23. Thread the wires through the helmet, using cable ties to hold in to place.
24. Connect everything back up and enjoy.