#include "FastLED.h"

#define LED_TYPE WS2812B
#define COLOR_ORDER GRB
#define NUM_LEDS 12

#define LEFT_DATA_PIN 9
CRGB leftLeds[NUM_LEDS];

#define RIGHT_DATA_PIN 11
CRGB rightLeds[NUM_LEDS];

#define BRIGHTNESS 255
#define FRAMES_PER_SECOND 60

#define LED_PIN 13

void setup() {
	pinMode(LED_PIN, OUTPUT);
	digitalWrite(LED_PIN, HIGH);
	Serial.begin(115200);
	FastLED.addLeds<LED_TYPE, LEFT_DATA_PIN, COLOR_ORDER>(leftLeds, NUM_LEDS).setCorrection(TypicalLEDStrip);
	FastLED.addLeds<LED_TYPE, RIGHT_DATA_PIN, COLOR_ORDER>(rightLeds, NUM_LEDS).setCorrection(TypicalLEDStrip);
	FastLED.setBrightness(BRIGHTNESS);
}

void dots() {
	fadeToBlackBy(leftLeds, NUM_LEDS, 20);
	int pos = random16(NUM_LEDS);

	leftLeds[pos] = pos < NUM_LEDS / 2 ? CRGB::DarkGrey : CRGB::Red;

	for (int i = 0; i < NUM_LEDS; i++)
		rightLeds[i] = leftLeds[NUM_LEDS - i];
}

void loop() {
	digitalWrite(LED_PIN, millis() < 1000); // We need to keep the LED on for a bit to draw enough power for the boost circuit to stay on.
	dots();
	FastLED.show();
	delay(1000 / FRAMES_PER_SECOND);
}
